/*--> ======================================================= <--*/
/*--> sort-calls.h : Include file listing all of the global   <--*/
/*-->                variables that need to be seen by all    <--*/
/*-->                the routines.                            <--*/
/*-->                                                         <--*/
/*-->                This version created by DEA Feb 27/03    <--*/
/*-->                                                         <--*/
/*--> ======================================================= <--*/
#ifndef _MIDASSORTGLOBALS_
#define  _MIDASSORTGLOBALS_
#ifdef WIN32
#include <windows.h>
#endif
/*--> ======================================================= <--*/
#include "midas_sort_defn.h"
/*--> ======================================================= <--*/
#define MAX_DATA_WRDS ( 1024 )
/*--> ======================================================= <--*/

#if (defined WIN32 || defined CYGWIN)
#ifdef WIN32
#define EXPORT __declspec(dllexport)
#define IMPORT __declspec(dllimport)
#else
#define EXPORT __declspec(dllexport)
#define IMPORT __declspec(dllimport)
#endif
#else
#define EXPORT
#define IMPORT extern
#endif

#ifdef WIN32
typedef short  *(* LPFNDLLFUNC2) ( short **, int **, int * );
typedef short  (* LPFNDLLFUNC1) ( unsigned short *, unsigned int *, unsigned int *, unsigned int * );
#endif

#ifndef WIN32
#define __FUNCTION__ ""
#endif


/*--> ======================================================= <--*/
struct SV {
 char specdir  [ 128 ];
 char inputdev [ 128 ];
 char outputdev[ 128 ];
 char inputfmt [ 128 ];
 char tdev     [ 128 ];
 int  overwritespectra;
 
 #ifdef WIN32
 LPFNDLLFUNC1 evt_routine;
 LPFNDLLFUNC2 blk_routine;
 #else
 short  (*evt_routine)( unsigned short *, unsigned int *, unsigned int *, unsigned int * );
 short  *(*blk_routine)( short **, int **, int * );
 #endif
 
 void *evt_module;
 void *blk_module;
} sort_vars;
/*--> ======================================================= <--*/
typedef struct s_ssinfo {
 char name [ 64 ];
 int  type;
 int  len;
 int  *pCount;
} SSINFO;

IMPORT SSINFO ssinfo[ MAX_SPECTRA ];
/*--> ======================================================= <--*/
struct SHIST {
 char        name [ 32 ];
 short int   group;
 short int   item;
 short int   label;
 short int   enable;
 short int   databits;
 int        *pCount;
} Myhist[ NUMHIST ];
/*--> ======================================================= <--*/
typedef struct s_myshare {
 int             action           ;
 int             debuglevel       ;
 int             toggle_hist      ;
 int             garray           ;
 int             mypos            ;
 int             trace            ;
 int             tracelevel       ;
 int             bad_jrc          ;
 int             useri       [ 4 ];
 unsigned int    userui      [ 4 ];
 short           users       [ 4 ];
 unsigned short  datablk [ 65536 ];
 float           gainarray        ;
 float           usersf      [ 4 ];
} MYSHARE;

IMPORT MYSHARE *myshare;
/*--> ======================================================= <--*/
struct DINFO {
  short start_pos[ MAX_DATA_WRDS ];
  short wrd_count[ MAX_DATA_WRDS ];
};
/*--> ======================================================= <--*/

/*    all message and error reporting via these   */
IMPORT void ReportError (char *);
IMPORT void ReportMessage (char *);
IMPORT char MessageBuffer[];

IMPORT volatile int gotsig;   /*--> Have we got a signal ..?  <--*/
IMPORT int *debug_level;
IMPORT int debug_status;
IMPORT int *trace_toggled;
IMPORT int *trace_level;
IMPORT int *bad_jrc;
IMPORT int *toggle_hist;
IMPORT int     *histconv;
IMPORT float   *gainarray;
IMPORT int     *gatelists;
IMPORT int            *guseri;
IMPORT unsigned int   *guserui;
IMPORT short          *gusers;
IMPORT float          *guserf;
/*--> ======================================================= <--*/
/*--> Some data storage stuff ...                             <--*/
unsigned int   *gid;
unsigned int   *gdata;
unsigned int   *nwrds;
int             mult;
int             gdblk_pos;
int             ui;
/*--> ======================================================= <--*/
/*--> Some shared memory stuff ..                             <--*/
int   shmid1;
/*--> ======================================================= <--*/
/*--> Some MIDAS related stuff ..                             <--*/
char   *exptdir;
/*--> ======================================================= <--*/
#endif
/*--> ========================================================== <--*/
